Unit AM08C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure AM08C(var A :Array of Complex; N :Integer; M :Integer;
                var B :Array of Complex);

implementation

procedure AM08C(var A :Array of Complex; N :Integer; M :Integer;
                var B :Array of Complex);
var
J,K,L :Integer;
R,E,A1 :Real;
S1,R1,R2,T,C,S :Complex;
label
_1,_2,_3;
begin
K := M-2;
if ( K <= 0 ) 
 then goto _3;
L := M-1;
_1:
J := M;
_2:
T := A[(K-1)+(J-1)*N];
E := Cabs(T);
R := E*E;
A1 := 1.0/(1.0+R);
C := Cmplx((1.0-R)*A1,0.0);
S := MulC((AddC(T,T)),Cmplx(A1,0.0));
S1 := Conjg(S);
R1 := B[L-1];
R2 := B[J-1];
B[L-1] := SubC(MulC(C,R1),MulC(S1,R2));
B[J-1] := AddC(MulC(S,R1),MulC(C,R2));
J := J-1;
if ( J > L ) 
 then goto _2;
L := K;
K := K-1;
if ( K > 0 ) 
 then goto _1;
_3:
end;

end.
